MiniMapViewer = class( Turbine.UI.Label );

function MiniMapViewer:Constructor(parent, canBeFocused, pos)
	Turbine.UI.Label.Constructor( self );
	pos = pos or 1;
	self:SetParent( parent );
	self.parent = parent;
	self:SetSize( 300, 200 );
	self:SetPosition( 0, 205*(pos-1) );
	self:SetZOrder(-99);
	self:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 );	
	self:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	self:SetMouseVisible( false );
	self:SetText(value);
	
	self.mapFlag = Turbine.UI.Label(); 
	self.mapFlag:SetParent( self );
	self.mapFlag:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.mapFlag:SetSize(13, 16);
	self.mapFlag:SetBackground("WalmPlugins/WarbandsSlayer/resources/tdg_flag2.tga");	

	self.switchPointsVisibility = SwitchLabel(16, 16, "WalmPlugins/WarbandsSlayer/resources/filterButton.tga", "WalmPlugins/WarbandsSlayer/resources/filterButton2.tga");
	self.switchPointsVisibility:SetParent( self );
	self.switchPointsVisibility:SetPosition(2, self:GetHeight()-18);
	self.switchPointsVisibility:SetMouseVisible( true );
	self.switchPointsVisibility.tooltip = ToolTip(self.switchPointsVisibility, "Filtrer les Marques", "Permet d'afficher toutes les marques ou seulement celles pas découvertes.");
	self.switchPointsVisibility:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.switchPointsVisibility.Toggled = function(parent, pushed)
		for i=1, table.getn(self.localisationArray), 1 do
			local array = self.localisationArray[i];
			array:SetVisible(pushed==false or not array:IsPushed());
		end		
	end

	self.validateAllPoints = Turbine.UI.Label();
	self.validateAllPoints:SetParent( self );
	self.validateAllPoints:SetPosition(20, self:GetHeight()-18);
	self.validateAllPoints:SetSize(16, 16);
	self.validateAllPoints:SetMouseVisible( true );
	self.validateAllPoints:SetBackground("WalmPlugins/WarbandsSlayer/resources/validatepoi.jpg");
	self.validateAllPoints.tooltip = ToolTip(self.validateAllPoints, "Valider toutes les Marques", "Permet de valider d'un coup toutes les marques de la carte.");
	self.validateAllPoints:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.validateAllPoints.MouseClick = function(sender, args)
		if(PoiProgress==nil) then PoiProgress = {}; end;
		
		if(PoiProgress[self.warband.id]==nil) then PoiProgress[self.warband.id]={}; end;
		for i=1, table.getn(self.localisationArray), 1 do			
			local array = self.localisationArray[i];
			PoiProgress[self.warband.id][array.mData.id] = true;
			array:SetPushed(true);
		end		
		SavePOI(false);
		warbandsDialog:AddCooldown(self.warband, self.warband.name, self:CheckCompletion(), false); 
	end

	self.validateQuest = Turbine.UI.Label();
	self.validateQuest:SetParent( self );
	self.validateQuest:SetPosition(2, self:GetHeight()-18);
	self.validateQuest:SetSize(16, 16);
	self.validateQuest:SetMouseVisible( true );
	self.validateQuest:SetBackground("WalmPlugins/WarbandsSlayer/resources/validatepoi.jpg");
	self.validateQuest.tooltip = ToolTip(self.validateQuest, "Indiquer la qu\195\170te comme faite", "Permet d'enregistrer la qu\195\170te comme faite, sans utiliser le detecteur auto.");
	self.validateQuest:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.validateQuest.MouseClick = function(sender, args)
		warbandsDialog:AddCooldown(nil, self.warband.name);
	end
	
	if(canBeFocused) then
		local selfView = Turbine.UI.Label();
		selfView:SetParent( self );
		selfView:SetPosition( self:GetWidth()-18, self:GetHeight()-18 );
		selfView:SetSize(16, 16);	
		selfView:SetBackground("WalmPlugins/WarbandsSlayer/resources/fullscreen.jpg");
		selfView:SetMouseVisible( true );
		selfView.tooltip = ToolTip(selfView, "Isoler la mini-map", "Permet de n'afficher que la mini-map.");
		selfView.MouseClick = function(sender, args)
			if(minimap:UpdateMap(self.warband, pos)~=nil) then
				warbandsDialog:SetVisible(false);
				minimap:SetVisible(true);
			end
		end	
	end
end

function MiniMapViewer:UpdateMap(warband, pos)
	
	if(warband==nil) then
		Turbine.Shell.WriteLine("<rgb=#FF5CCD>ERROR UpdateComponents gets nil warband</rgb>");
		return false;
	end
	self.warband = warband;
	if(self.localisationArray ~= nil) then
		while(table.getn(self.localisationArray) > 0) do
			local lab = table.remove(self.localisationArray);
			lab:SetParent(nil);
			lab.tooltip = nil;
			lab = nil;
		end
	end
	self.localisationArray = {};
	
	if(warband.map ~= nil) then
		self:SetBackground("WalmPlugins/WarbandsSlayer/resources/maps/"..warband.map);
	end
	if(warband.enemyType == 2 and Filters.tab==2) then
		self.mapFlag:SetVisible(false);
		self.switchPointsVisibility:SetVisible(false);
		self.validateQuest:SetVisible(true);
		self.validateAllPoints:SetVisible(false);
		for id=1, table.getn(warband.rovingThreatData.loc), 1 do
			local mData = warband.rovingThreatData.loc[id];
			-- k.m  k.c  k.l
			local mFlag = Turbine.UI.Label(); 
			mFlag:SetParent( self );
			mFlag:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
			mFlag:SetSize(13, 16);
			mFlag:SetBackground("WalmPlugins/WarbandsSlayer/resources/tdg_flag2.tga");	
			mFlag:SetPosition(mData.m.x-6,mData.m.y-8);
			table.insert(self.localisationArray, mFlag);
			mFlag.tooltip = ToolTip(mFlag, "Coordonn\195\169es : "..mData.c, mData.l);
		end
	elseif((warband.poi~=nil or warband.multipoi~=nil) and Filters.tab==3) then
		self.mapFlag:SetVisible(false);
		self.switchPointsVisibility:SetVisible(true);
		self.validateAllPoints:SetVisible(true);
		self.validateQuest:SetVisible(false);
		local backgroundOn = "WalmPlugins/WarbandsSlayer/resources/chest.jpg";
		local backgroundOff = "WalmPlugins/WarbandsSlayer/resources/chestFound.jpg";
		local size = 16;
		if(warband.ico~=nil) then
			backgroundOn = "WalmPlugins/WarbandsSlayer/resources/"..warband.ico;
			backgroundOff = "WalmPlugins/WarbandsSlayer/resources/poiok.jpg";
			size = 12;
		end	
		local poiarray = warband.poi;
		if(warband.multipoi~=nil) then
			poiarray = warband.multipoi[pos].poi;
			self:SetBackground("WalmPlugins/WarbandsSlayer/resources/maps/"..warband.multipoi[pos].map);
		end
		for id=1, table.getn(poiarray), 1 do
			local mData = poiarray[id];
			-- k.m  k.c  k.l
			local mFlag = SwitchLabel(size, size, backgroundOn, backgroundOff); 
			mFlag:SetParent( self );
			mFlag:SetPosition(mData.m.x-6,mData.m.y-8);
			mFlag.mData = mData;
			mFlag.Toggled = function(parent, pushed)
				if(PoiProgress==nil) then PoiProgress = {}; end;
				if(PoiProgress[warband.id]==nil) then PoiProgress[warband.id]={}; end;
				PoiProgress[warband.id][mData.id] = pushed;
				SavePOI(false);
				warbandsDialog:AddCooldown(warband, warband.name, self:CheckCompletion(), false);					
			end
			local alreadyFound = false;
			if(PoiProgress~=nil and PoiProgress[warband.id]~=nil and PoiProgress[warband.id][mData.id]~=nil)then
				alreadyFound = PoiProgress[warband.id][mData.id];
			end
			mFlag:SetPushed(alreadyFound);
			local comment = mData.l;
			if(alreadyFound)then
				comment = "Déjà trouvé !";
			end					
			table.insert(self.localisationArray, mFlag);
			mFlag.tooltip = ToolTip(mFlag, "Coordonn\195\169es : "..mData.c, comment);					
		end				
	elseif(warband.mapPos ~= nil) then
		self.mapFlag:SetVisible(true);
		self.switchPointsVisibility:SetVisible(false);
		self.validateAllPoints:SetVisible(false);
		self.validateQuest:SetVisible(true);
		self.mapFlag:SetPosition(warband.mapPos.x-6, warband.mapPos.y-8);
	end

	return true;
end

function MiniMapViewer:CheckCompletion()

	local okCnt = 0;
	for i=1, table.getn(PoiProgress[self.warband.id]), 1 do 
		if(PoiProgress[self.warband.id][i]==true) then okCnt=okCnt+1; end
	end
	if(self.warband.poi~=nil) then 
		return okCnt==table.getn(self.warband.poi);
	elseif(self.warband.multipoi~=nil) then
		local count=0;
		for i=1, table.getn(self.warband.multipoi), 1 do 
			local poi = self.warband.multipoi[i];
			count = count + table.getn(poi.poi);
		end
		return okCnt==count;
	end	
	return false;
end

function MiniMapViewer:Unload()
	for i=1, table.getn(self.localisationArray), 1 do
		local array = self.localisationArray[i];
		array.tooltip:Free();
		array.tooltip = nil;
		array = nil;
	end
	if(self.mapFlag.tooltip~=nil) then 
		self.mapFlag.tooltip:SetVisible(false);	
		self.mapFlag.tooltip = nil;
	end
end