import "WalmPlugins.WarbandsSlayer.src.LerpValue";

QuickLauncher = class( Turbine.UI.Window );

function QuickLauncher:Constructor(dialog)
	Turbine.UI.Window.Constructor( self );
	
	--self.defaultOpacity = 0.6;
	local width, height = Turbine.UI.Display.GetSize();
	self:SetSize(50, 45);
	self:SetPosition(Preferences.quicklaunch_x, Preferences.quicklaunch_y);
	self:SetOpacity(Preferences.defaultOpacity / 100);
	
	self.background = Turbine.UI.Label();
	self.background:SetParent( self );
	self.background:SetBackground( "WalmPlugins/WarbandsSlayer/resources/quicklauncher.tga" );
	self.background:SetPosition( 0, 0 );
	self.background:SetSize(40, 45);
	self.background:SetMouseVisible( false );
	self.background:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );	

	self.qsBubble = Turbine.UI.Lotro.Quickslot();
	self.qsBubble:SetParent(self);
	self.qsBubble:SetSize(16,16);
	self.qsBubble:SetPosition(34,0);
	--self.qsBubble:SetVisible(false);	
	self.qsBubble:SetBackColor( Turbine.UI.Color( 0.6, 0, 0, 0 ) );
	self.qsBubble:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, ""));	
	self.qsBubble:SetAllowDrop(false);
	self.qsBubble:SetEnabled(false);
	
	-- self.wbBubble = Turbine.UI.Label();
	-- self.wbBubble:SetParent(self);
	-- self.wbBubble:SetSize(16,16);
	-- self.wbBubble:SetPosition(34,22);
	-- self.wbBubble:SetBackground( "WalmPlugins/WarbandsSlayer/resources/bubble2.tga" );
	-- self.wbBubble:SetVisible(false);	
	
	local c= Turbine.UI.Control();
	c:SetParent(self);
	c:SetSize(self.qsBubble:GetSize());
	c:SetPosition(self.qsBubble:GetLeft(),self.qsBubble:GetTop());
	c:SetMouseVisible(false);
	c:SetZOrder(10000);
	c:SetBackColor(Turbine.UI.Color( .7, .7, .7 ));
	--c:SetVisible(false);
	self.qsLbl = c;
	
	c= Turbine.UI.Label()
	c:SetParent(self.qsLbl);
	c:SetPosition(1,1);
	--c:SetVisible(false);	
	c:SetSize(self.qsBubble:GetWidth()-2,self.qsBubble:GetHeight()-2);
	c:SetMouseVisible(false);
	c:SetZOrder(10001);
	c:SetBackground( "WalmPlugins/WarbandsSlayer/resources/bubble.tga" );
	
	self.qsBubble:SetVisible(false);
	self.qsLbl:SetVisible(false);
	
	self.counter = Turbine.UI.Label();
	self.counter:SetParent( self );
	self.counter:SetText( "0/30" );
	self.counter:SetPosition(0, 29);
	self.counter:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter ); 
	--self.counter:SetFont(Turbine.UI.Lotro.Font.Verdana10); 
	self.counter:SetFont(Turbine.UI.Lotro.Font.Arial12); 
	self.counter:SetSize(40, 14);
	self.counter:SetMouseVisible( false );
	--self.counter:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	
	local contextMenu = Turbine.UI.ContextMenu();
	menuItems = contextMenu:GetItems();
	local openMenuItem = Turbine.UI.MenuItem( "Ouvrir la liste des Troupes" );
	local configMenuItem = Turbine.UI.MenuItem( "Ouvrir le panneau de configuration" );
    menuItems:Add( openMenuItem );
    menuItems:Add( configMenuItem );
	openMenuItem.Click = function(sender, args)
		dialog:SetVisible( not dialog:IsVisible() );
	end
	configMenuItem.Click = function(sender, args)
		local configDialog = GetConfigurationDialogInstance();
		configDialog:SetVisible(true);
	end
	
	self.MouseEnter = function(sender,args)
		--self.button:SetBackground("Chiran/Songbook/toggle_hover.tga");
		self:SetOpacity(1.0);
	end
	self.MouseLeave = function(sender,args)
		--self.button:SetBackground("Chiran/Songbook/toggle.tga");
		self:SetOpacity(Preferences.defaultOpacity / 100);
	end		
	self.MouseDown = function( sender, args )
		if(args.Button == Turbine.UI.MouseButton.Left and Preferences.canMoveQuickLauncher) then
			sender.dragStartX = args.X;
			sender.dragStartY = args.Y;
			sender.dragging = true;
			sender.dragged = false;
			--self:SetBackColor( Turbine.UI.Color(0,0,1,0) );
		end
	end
	self.MouseUp = function( sender, args )
		if (args.Button == Turbine.UI.MouseButton.Left) then			
			if (sender.dragging) then
				sender.dragging = false;
			end
			if not sender.dragged then
				dialog:SetVisible( not dialog:IsVisible() );
			end
			---self:SetBackColor( Turbine.UI.Color(0,0,0,0) );
			Preferences.quicklaunch_x, Preferences.quicklaunch_y = self:GetPosition();
			SavePreferences();
			if(Preferences.OnUpdate ~= nil) then
				Preferences.OnUpdate();
			end
		elseif (args.Button == Turbine.UI.MouseButton.Right) then	
			contextMenu:ShowMenu();
		end
	end
	self.MouseMove = function(sender,args)
		if ( sender.dragging ) then
			local left, top = self:GetPosition();
			self:SetPosition( left + ( args.X - sender.dragStartX ), top + args.Y - sender.dragStartY );
			sender.dragged = true;
			if (self:GetLeft() > Turbine.UI.Display.GetWidth() - 35) then
				self:SetLeft(Turbine.UI.Display.GetWidth() - 35);				
			end
			if (self:GetLeft() < 0) then
				self:SetLeft(0);				
			end			
			if (self:GetTop() > Turbine.UI.Display.GetHeight() - 35) then
				self:SetTop(Turbine.UI.Display.GetHeight() - 35);				
			end
			if (self:GetTop() < 0) then
				self:SetTop(0);				
			end			
		end
	end
	
	self.lastUpdate = 0;
	self.blinker = LerpValue();
	self.blinker:SetRate(60);
	
	self:ApplyPreferences();
	
	-- Hide UI when F12 is pressed, code copied from Chiran sources
	local hideUI = false;
	local wasVisible;
	self:SetWantsKeyEvents(true);
	self.KeyDown = function(sender, args)
		if (args.Action == 268435635) then
			if not hideUI then
				hideUI = true;
				if self:IsVisible() then
					wasVisible = true;
					self:SetVisible(false);					
				else
					wasVisible = false;
				end
				-- settingsWindow:SetVisible(false);
				-- toggleWindow:SetVisible(false);
			else
				hideUI = false;
				if wasVisible then
					self:SetVisible(true);
					-- settingsWindow:SetVisible(false);					
				end
				-- if (Settings.ToggleVisible == "yes") then
					-- toggleWindow:SetVisible(true);
				-- end
			end
		end
	end
	--self:ManageTarget();
	self:InitTargetLogger();
end

function QuickLauncher:NotifyUpdate(doneCount, total, justkilled, typeId)
	--Turbine.Shell.WriteLine("<rgb=#FF5CCD>QUICKLAUNCHER Vous avez aujourd\'hui trucid\195\169 "..doneCount.." troupes de guerre sur "..total.."</rgb>");
	if(typeId==2) then
		self.background:SetBackground( "WalmPlugins/WarbandsSlayer/resources/quicklauncher2.tga" );
	elseif(typeId==3) then
		self.background:SetBackground( "WalmPlugins/WarbandsSlayer/resources/quicklauncher3.tga" );
	else
		self.background:SetBackground( "WalmPlugins/WarbandsSlayer/resources/quicklauncher.tga" );
	end
	self.counter:SetText( doneCount.."/"..total );
	if(justkilled==nil or justkilled==false) then
		self.blinker.iteration = 4;
		self.blinker:SetTarget(Preferences.defaultOpacity);
		self.blinker:SetValue(0);
	else
		self.blinker.iteration = 5;
		self.blinker:SetTarget(0);
		self.blinker:SetValue(self:GetOpacity()*100);	
	end
	self:SetWantsUpdates( true );
	
end

function QuickLauncher:Update( args )
	local delta = 0;
	local currentTime = Turbine.Engine.GetGameTime();

	if ( self.lastUpdate > 0 ) then
		delta = currentTime - self.lastUpdate;
	end

	self.lastUpdate = currentTime;
	
	self.blinker:Update( delta );
	--Turbine.Shell.WriteLine("<rgb=#FF5CCD>UPDATE  - delta=".. delta .." - value="..  math.floor(self.blinker:GetValue()) .."/"..  math.floor(self.blinker:GetTargetValue()) .."</rgb>");
	self:SetOpacity(self.blinker:GetValue()/100);
	
	if (not self.blinker:NeedsUpdate()) then
		if(self.blinker.iteration > 0) then
			if(self.blinker.iteration%2==0) then
				self.blinker:SetTarget(0);
				self.blinker:SetValue(Preferences.defaultOpacity);
			else
				self.blinker:SetTarget(Preferences.defaultOpacity);
				self.blinker:SetValue(0);
			end
			self.blinker.iteration = self.blinker.iteration - 1;
		else
			self:SetWantsUpdates( false );
			self.lastUpdate = 0;
			--Turbine.Shell.WriteLine("<rgb=#FF5CCD>UPDATE  - TERMINE</rgb>");
		end
	end	
end

function QuickLauncher:ApplyPreferences()
	self:SetPosition(Preferences.quicklaunch_x, Preferences.quicklaunch_y);
	self:SetOpacity(Preferences.defaultOpacity / 100);
end

function QuickLauncher:GetName()
	return "QuickLauncher";
end

function QuickLauncher:IsRunning()
	return ( self ~= nil );
end

function QuickLauncher:Start()
	if ( self ~= nil ) then
		self:SetVisible( true );
		return;
	end	
end

function QuickLauncher:Stop()
	self:SetVisible(false);
	self = nil;
end

function QuickLauncher:ManageTarget()
	local player=Turbine.Gameplay.LocalPlayer.GetInstance();
	player.TargetChanged=function()
		local target=player:GetTarget()
		if target~=nil then
			local targetname = target:GetName();
			Turbine.Shell.WriteLine("<rgb=#FF5CCD>QuickLauncher : ".. targetname .."</rgb>");
			wb = GetWarbandByQuestName(targetname);
			--wb = GetWarbandByQuestName("snathletratre");
			if(wb==nil and target~=nil) then
				local wbName2 = StringCleaner(targetname);
				wb = GetWarbandByQuestName(wbName2);
			end
			if(wb == nil) then
				--Turbine.Shell.WriteLine("<rgb=#FF5CCD>Erreur, aucune troupe de guerre ou Menace itin\195\169rante du nom de "..targetname.." trouv\195\169e. Cette Troupe est donc ignor\195\169e!</rgb>");				
				--self.bubble:SetVisible(false);
				self.qsBubble:SetVisible(false);
				--self.wbBubble:SetVisible(false);
				self.qsLbl:SetVisible(false);
			else
				local message;
				if(wb.enemyType==2) then
					message = FromUTF8("La menace itinérante ");
				else
					message = "La troupe de guerre ";
				end
				local canal = "/monde";
				if(Preferences.chatCanal=="Canal R\195\169gional") then
					canal = FromUTF8("/régional");
				elseif(Preferences.chatCanal=="Canal de Confr\195\169rie") then
					canal = "/k";
				elseif(Preferences.chatCanal=="Canal de Communaut\195\169") then
					canal = "/f";
				elseif(Preferences.chatCanal=="Canal du Raid") then
					canal = "/ra";
				end
				
				message = message..FromUTF8(wb.name) ..FromUTF8(" a été repérée !");
				self.qsBubble:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, 
												canal.." <rgb=#FF5CCD>".. message .."\n=> ;loc</rgb>"));	
				self.qsBubble:SetVisible(true);
				--self.wbBubble:SetVisible(true);
				self.qsLbl:SetVisible(true);
				warbandsDialog:FocusOnWarband(wb);
			end
		else
			--self.bubble:SetVisible(false);
			self.qsBubble:SetVisible(false);
			self.qsLbl:SetVisible(false);
		end
	end
end

function QuickLauncher:InitTargetLogger()
	if(Turbine.Gameplay.LocalPlayer.targetListerners == nil) then
		Turbine.Gameplay.LocalPlayer.targetListerners = {};
		local player=Turbine.Gameplay.LocalPlayer.GetInstance();
		player.TargetChanged = function (sender, args)
			for i, j in pairs(Turbine.Gameplay.LocalPlayer.targetListerners) do
				j:TargetChanged(sender, args);
			end
		end
		-- local tempMessage = tostring(args.Message);
	end
	if (Turbine.Gameplay.LocalPlayer.targetListerners ~= nil) then
		for i, j in pairs(Turbine.Gameplay.LocalPlayer.targetListerners) do
			if(j==self) then return; end
		end
		table.insert(Turbine.Gameplay.LocalPlayer.targetListerners, self);
		--Turbine.Shell.WriteLine( "SkirmishDetector ECHO: "..table.getn(Turbine.Gameplay.LocalPlayer.targetListerners));
	end	
end

function QuickLauncher:TargetChanged(sender, args)
	local player=Turbine.Gameplay.LocalPlayer.GetInstance();
	local target=player:GetTarget();
	if target~=nil then
		local targetname = target:GetName();
		--Turbine.Shell.WriteLine("<rgb=#FF5CCD>QuickLauncher : ".. targetname .."</rgb>");
		wb = GetWarbandByQuestName(targetname);
		--wb = GetWarbandByQuestName("snathletratre");
		if(wb==nil and target~=nil) then
			local wbName2 = StringCleaner(targetname);
			wb = GetWarbandByQuestName(wbName2);
		end
		if(wb == nil) then
			--Turbine.Shell.WriteLine("<rgb=#FF5CCD>Erreur, aucune troupe de guerre ou Menace itin\195\169rante du nom de "..targetname.." trouv\195\169e. Cette Troupe est donc ignor\195\169e!</rgb>");				
			--self.bubble:SetVisible(false);
			self.qsBubble:SetVisible(false);
			self.qsLbl:SetVisible(false);
		else
			local message;
			if(wb.enemyType==2) then
				message = FromUTF8("La menace itinérante ");
			else
				message = "La troupe de guerre ";
			end
			local canal = "/monde";
			if(Preferences.chatCanal=="Canal R\195\169gional") then
				canal = FromUTF8("/régional");
			elseif(Preferences.chatCanal=="Canal de Confr\195\169rie") then
				canal = "/k";
			elseif(Preferences.chatCanal=="Canal de Communaut\195\169") then
				canal = "/f";
			elseif(Preferences.chatCanal=="Canal du Raid") then
				canal = "/ra";
			end
			
			message = message..FromUTF8(wb.name) ..FromUTF8(" a été repérée !");
			self.qsBubble:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, 
			canal.." <rgb=#FF5CCD>".. message .."\n=> ;loc</rgb>"));	
			self.qsBubble:SetVisible(true);
			self.qsLbl:SetVisible(true);
			warbandsDialog:FocusOnWarband(wb);
		end
	else
		--self.bubble:SetVisible(false);
		self.qsBubble:SetVisible(false);
		self.qsLbl:SetVisible(false);
	end
end