import "WalmPlugins.WarbandsSlayer.src.WarbandSubPane";
import "WalmPlugins.WarbandsSlayer.src.InterNode";
import "WalmPlugins.WarbandsSlayer.src.TextNode";
import "WalmPlugins.WarbandsSlayer.src.SwitchLabel";
import "WalmPlugins.WarbandsSlayer.src.MiniMapViewer";

WarbandPane = class( Turbine.UI.Label );

function WarbandPane:Constructor(width, height)	  	
	Turbine.UI.Label.Constructor( self );    	
	self:SetSize( width, height );
	--self:SetBackColor(Turbine.UI.Color( 0.2, 0.2, 0.2 ));
	
	self.header = Turbine.UI.Control();
	self.header:SetParent( self );
	self.header:SetSize(378, 92);
	self.header:SetPosition((width-378)/2, 2);	
	self.header:SetMouseVisible( false );
	self.header:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.header:SetBackground("WalmPlugins/WarbandsSlayer/resources/header_details2.tga");
	
	self.frame = Turbine.UI.Control();
	self.frame:SetParent( self );
	self.frame:SetSize(62, 62);
	self.frame:SetPosition((width-62)/2, 2);	
	self.frame:SetMouseVisible( false );
	self.frame:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );	
	
	self.difficultyIcone = Turbine.UI.Control();
	self.difficultyIcone:SetParent( self );
	self.difficultyIcone:SetSize(34, 44);
	self.difficultyIcone:SetPosition(width-40, 2);	
	self.difficultyIcone:SetMouseVisible( false );
	self.difficultyIcone:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );		
	
	self.wbName = Turbine.UI.Label();
	self.wbName:SetParent( self );
	self.wbName:SetSize(width-30, 31);
	self.wbName:SetPosition(15, 63);
	self.wbName:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16);	
	self.wbName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.wbName:SetMouseVisible( false );
	self.wbName:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	--self.wbName:SetBackColor( Turbine.UI.Color( 0.5, 0.5, 0.5 ) );

	self.wbPlace = Turbine.UI.Label();
	self.wbPlace:SetParent( self );
	self.wbPlace:SetSize(152, 32);
	self.wbPlace:SetPosition(5, 10);
	self.wbPlace:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);	
	self.wbPlace:SetMouseVisible( false );
	self.wbPlace:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.wbPlace:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	
	self:CreateInfoTreeview()
	
	self:SetVisible(false);
end

function WarbandPane:CreateInfoTreeview()
	self.treeView = Turbine.UI.TreeView();
    self.treeView:SetParent( self );
    self.treeView:SetPosition( self.header:GetLeft(), self.header:GetTop()+self.header:GetHeight()+10 );
    self.treeView:SetSize( self.header:GetWidth()-10, self:GetHeight()-self.treeView:GetTop() );
	--self.treeView:SetBackColor( Turbine.UI.Color( 0.5, 0.5, 0.5 ) );
    self.treeView:SetIndentationWidth( 15 );
	
	treeViewScrollBar = Turbine.UI.Lotro.ScrollBar();
    treeViewScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
    treeViewScrollBar:SetParent( self );
    treeViewScrollBar:SetPosition( self.treeView:GetLeft()+self.treeView:GetWidth(), self.treeView:GetTop() );
    treeViewScrollBar:SetSize( 10, self.treeView:GetHeight() );
	self.treeView:SetVerticalScrollBar( treeViewScrollBar );
	
	self:CreateLocalisationNode();
	self:CreateDetailsNode();
	self:CreateStatsNode();
	self:CreateRewardsNode();
	
	self.treeView:ExpandAll();
end

function WarbandPane:CreateLocalisationNode()
	local rootNodes = self.treeView:GetNodes();
	
	self.noteNode = TextNode("INSERT_HERE_NOTE", nil, 360, 32);
	self.noteNode.labelKey:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.noteNode.labelKey:SetForeColor(Turbine.UI.Color( 1.0, 0.0, 0.0 ))
	rootNodes:Add( self.noteNode );
	
	local node = AreaNode("Localisation");
	rootNodes:Add( node );	
	
	self.locationNode = TextNode(ToUTF8("Coordonnes:"), "INSERT_HERE_LOCALISATION");
	node:GetChildNodes():Add(self.locationNode);
	
	self.localisationPOINode = TextNode(ToUTF8("A ct de:"), "INSERT_HERE_CLOSED_POI");
	node:GetChildNodes():Add(self.localisationPOINode);
	
	self.spawnsharedNode = TextNode("Spawn commun:");
	node:GetChildNodes():Add(self.spawnsharedNode);
	
	self.mapTitleNode = AreaNode("Carte");
	node:GetChildNodes():Add(self.mapTitleNode);
	self.mapNode = Turbine.UI.TreeNode();
	self.mapNode:SetSize( 300, 200 );
	self.mapNode:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	--self.mapNode:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) );
	self.mapNode:SetMouseVisible( false );
	self.mapNode.mapsViewers = {};
	self.mapTitleNode:GetChildNodes():Add(self.mapNode);
	
	self.mapTitleNode:CollapseAll();
	self.pnjNode = TextNode("PNJ de Qu\195\170te:", nil, 340, 16);
	node:GetChildNodes():Add(self.pnjNode);	
	
	rootNodes:Add(InterNode(10));
end

function WarbandPane:CreateDetailsNode()
	local rootNodes = self.treeView:GetNodes();
	self.infoNode = AreaNode("Informations");
	rootNodes:Add( self.infoNode );
	
	local detailsNode = Turbine.UI.TreeNode();
	detailsNode:SetSize( 350, 30 );
	detailsNode:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	--detailsNode:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) );
	self.infoNode:GetChildNodes():Add(detailsNode);	
	
	self.raceTitleLabel = Turbine.UI.Label();
	self.raceTitleLabel:SetParent( detailsNode );
	self.raceTitleLabel:SetText("Race:");
	self.raceTitleLabel:SetPosition( 0, 0 );
	self.raceTitleLabel:SetSize(360, 16);
	self.raceTitleLabel:SetMouseVisible( false );	
	self.raceLabel = Turbine.UI.Label();
	self.raceLabel:SetParent( detailsNode );
	self.raceLabel:SetText("INSERT_HERE_RACE");
	self.raceLabel:SetPosition( 100, 0 );
	self.raceLabel:SetSize(360, 16);
	self.raceLabel:SetMouseVisible( false );
	
	self.moralTitleLabel = Turbine.UI.Label();
	self.moralTitleLabel:SetParent( detailsNode );
	self.moralTitleLabel:SetText("Moral:");
	self.moralTitleLabel:SetPosition( 0, 15 );
	self.moralTitleLabel:SetSize(360, 16);
	self.moralTitleLabel:SetMouseVisible( false );	
	self.moralLabel = Turbine.UI.Label();
	self.moralLabel:SetParent( detailsNode );
	self.moralLabel:SetText("INSERT_HERE_MORAL");
	self.moralLabel:SetPosition( 100, 15 );
	self.moralLabel:SetSize(360, 16);
	self.moralLabel:SetMouseVisible( false );	

	self.addsTitleNode = AreaNode("Adds");
	self.infoNode:GetChildNodes():Add(self.addsTitleNode);

	-- detailsNode:SetExpanded(true);
	rootNodes:Add(InterNode(10));	
end

function WarbandPane:CreateStatsNode()
	local rootNodes = self.treeView:GetNodes();
	self.statNode = AreaNode("Statistiques");
	rootNodes:Add( self.statNode );
	
	local statsNode = Turbine.UI.TreeNode();
	statsNode:SetSize( 350, 40 );
	statsNode:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	--statsNode:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) );
	self.statNode:GetChildNodes():Add(statsNode);
	
	self.lastkillLabel = Turbine.UI.Label();
	self.lastkillLabel:SetParent( statsNode );
	self.lastkillLabel:SetText("INSERT_HERE_KILL_DATE");
	self.lastkillLabel:SetPosition( 0, 0 );
	self.lastkillLabel:SetSize(360, 16);
	self.lastkillLabel:SetMouseVisible( false );
	
	self.nbKillLabel = Turbine.UI.Label();
	self.nbKillLabel:SetParent( statsNode );
	self.nbKillLabel:SetText("INSERT_HERE_NBKILL");
	self.nbKillLabel:SetPosition( 0, 15 );
	self.nbKillLabel:SetSize(360, 16);
	self.nbKillLabel:SetMouseVisible( false );
	
	-- statsNode:SetExpanded(true);
	rootNodes:Add(InterNode(10));	
end

function WarbandPane:CreateRewardsNode()
	local rootNodes = self.treeView:GetNodes();
	local node = AreaNode( ToUTF8("Rcompenses" ));
	rootNodes:Add( node );
	
	local rewardsNode = Turbine.UI.TreeNode();
	rewardsNode:SetSize( 350, 40 );
	rewardsNode:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	--rewardsNode:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) );
	node:GetChildNodes():Add(rewardsNode);
	
	local rewardFrameLabel = Turbine.UI.Label();
	rewardFrameLabel:SetParent( rewardsNode );
	rewardFrameLabel:SetPosition(0, 0);
	rewardFrameLabel:SetSize(350, 40); --359
	rewardFrameLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );	
	rewardFrameLabel:SetBackground("WalmPlugins/WarbandsSlayer/resources/rewardsframe.tga");
	rewardFrameLabel:SetMouseVisible( false );
	
	self.reward1Label = Turbine.UI.Label();
	self.reward1Label.counter = Turbine.UI.Label();
	self:InitiateRewardPane(self.reward1Label, rewardFrameLabel, 1);
	self.reward2Label = Turbine.UI.Label();
	self.reward2Label.counter = Turbine.UI.Label();
	self:InitiateRewardPane(self.reward2Label, rewardFrameLabel, 2);
	self.reward3Label = Turbine.UI.Label();
	self.reward3Label.counter = Turbine.UI.Label();
	self:InitiateRewardPane(self.reward3Label, rewardFrameLabel, 3);
	self.reward4Label = Turbine.UI.Label();
	self.reward4Label.counter = Turbine.UI.Label();
	self:InitiateRewardPane(self.reward4Label, rewardFrameLabel, 4);
	self.reward5Label = Turbine.UI.Label();
	self.reward5Label.counter = Turbine.UI.Label();
	self:InitiateRewardPane(self.reward5Label, rewardFrameLabel, 5);
	self.reward6Label = Turbine.UI.Label();
	self.reward6Label.counter = Turbine.UI.Label();
	self:InitiateRewardPane(self.reward6Label, rewardFrameLabel, 6);
	self.reward7Label = Turbine.UI.Label();
	self.reward7Label.counter = Turbine.UI.Label();
	self:InitiateRewardPane(self.reward7Label, rewardFrameLabel, 7);
	self.reward8Label = Turbine.UI.Label();
	self.reward8Label.counter = Turbine.UI.Label();
	self:InitiateRewardPane(self.reward8Label, rewardFrameLabel, 8);
	
	-- rewardsNode:SetExpanded(true);
end

function WarbandPane:InitiateRewardPane(cpt, parent, id)
	cpt:SetParent( parent );
	cpt:SetPosition(12+(id-1)*38, 4);
	cpt:SetSize(32, 32);
	cpt:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	cpt:SetBackground("WalmPlugins/WarbandsSlayer/resources/rewards/gold.jpg");
	--cpt.counter = Turbine.UI.Label();
	cpt.counter:SetParent(cpt);
	cpt.counter:SetPosition(15, 23);
	cpt.counter:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	cpt.counter:SetSize(15, 10);
	--counter:SetText("0");
end

function WarbandPane:SetWarband(warband, wbCooldown, mapName) --lastKillDate)  	
	if(warband == nil) then
		self:SetVisible(false);
		return;
	end
	self:SetVisible(true);
	
	if(warband.frame==nil) then
		self.frame:SetBackground("WalmPlugins/WarbandsSlayer/resources/frames/default.tga");
	else
		self.frame:SetBackground("WalmPlugins/WarbandsSlayer/resources/frames/"..warband.frame);
	end
	self.wbName:SetText("["..warband.level.."] "..warband.name);	
	
	self.noteNode:SetText(warband.note);
	
	self.wbPlace:SetText(mapName);
	self.mapTitleNode:SetVisible(false);
	self.mapNode:SetVisible(false);
	self.locationNode:SetVisible(true);

	for i=1 , table.getn(self.mapNode.mapsViewers), 1 do
		self.mapNode.mapsViewers[i]:Unload();
		self.mapNode.mapsViewers[i]:SetParent(nil);
		--self.mapNode.mapsViewers[i] = nil;
	end
	self.mapNode.mapsViewers = {};
	if(warband.poi~=nil or warband.loc~=nil) then
		local mapViewer = MiniMapViewer(self.mapNode, true);
		table.insert(self.mapNode.mapsViewers, mapViewer);
		if mapViewer:UpdateMap(warband) == true then
			self.mapTitleNode:SetVisible(true);
			self.mapNode:SetVisible(true);
			self.mapNode:SetSize( 300, 200 );
		end
	elseif(warband.multipoi ~= nil) then
		for i=1 , table.getn(warband.multipoi), 1 do
			local mapViewer = MiniMapViewer(self.mapNode, true, i);
			table.insert(self.mapNode.mapsViewers, mapViewer);
			mapViewer:UpdateMap(warband, i)
		end
		self.mapTitleNode:SetVisible(true);
		self.mapNode:SetVisible(true);
		self.mapNode:SetSize( 300, table.getn(warband.multipoi)*205);		
	end
	
	self.pnjNode:SetVisible(warband.pnj~=nil);
	if(warband.pnj ~= nil) then
		self.pnjNode:SetValue(warband.pnj);
	end
	
	self.moralLabel:SetText(warband.moral);
	if(warband.difficulty ~= nil) then
		self.moralLabel:SetText(warband.moral.." ("..warband.difficulty.name..")");
	end
	--self.detailsLabel:SetText(warband.comment);
	self.raceLabel:SetText(warband.race);
	
	-- Adds
	
	local isExpanded = self.addsTitleNode:IsExpanded();
	self.addsTitleNode:GetChildNodes():Clear();
	
	if(warband.adds~=nil) then
		local count = 0;
		for i=1, table.getn(warband.adds), 1 do
			local adds = warband.adds[i];
			local libelle = adds[1].." "..adds[2];
			if(adds[3]~=nil) then
				libelle = libelle.." ("..adds[3].name..")";
			end
			self.addsTitleNode:GetChildNodes():Add(TextNode(libelle));
			count = count + adds[1];
		end
		-- if(table.getn(warband.adds)==0) then
			-- self.addsTitleNode:GetChildNodes():Add(TextNode(ToUTF8("Aucun add rpertori")));
		-- end
		local endtitle = "";
		if(warband.addlinked == true) then
			endtitle = " <<Li\195\169s au boss>>";
		end
		self.addsTitleNode:SetValue("Adds [".. count .."]"..endtitle);
	else
		self.addsTitleNode:SetValue("Adds TBD");
		--self.addsTitleNode:GetChildNodes():Add(TextNode("TBD"));
	end
	self.addsTitleNode:SetExpanded(isExpanded);
	
	if(warband.rewards~=nil) then
		self:UpdateRewardLabel(self.reward1Label, 1, warband);
		self:UpdateRewardLabel(self.reward2Label, 2, warband);
		self:UpdateRewardLabel(self.reward3Label, 3, warband);
		self:UpdateRewardLabel(self.reward4Label, 4, warband);
		self:UpdateRewardLabel(self.reward5Label, 5, warband);
		self:UpdateRewardLabel(self.reward6Label, 6, warband);
		self:UpdateRewardLabel(self.reward7Label, 7, warband);
		self:UpdateRewardLabel(self.reward8Label, 8, warband);
	end
	
	self.difficultyIcone:SetBackground("WalmPlugins/WarbandsSlayer/resources/difficulty/"..warband.size.."_large.tga");
	self.lastkillLabel:SetText("Vous ne l'avez jamais tu\195\169 :/");
	self.nbKillLabel:SetVisible( false );	
	if(wbCooldown ~= nil) then
		self.nbKillLabel:SetVisible( true );	
		self.nbKillLabel:SetText("Vous l'avez tu\195\169 au moins une fois :P"); -- fix update issue
		local digit = ""; if(wbCooldown[2].Minute<10)then digit="0";end
		self.lastkillLabel:SetText("Tu\195\169 le "..wbCooldown[2].Day.."/"..wbCooldown[2].Month.."/"..wbCooldown[2].Year.." \195\160 "..wbCooldown[2].Hour.."h"..digit..wbCooldown[2].Minute);
		if(wbCooldown[3]~=nil) then self.nbKillLabel:SetText("Tu\195\169 ".. wbCooldown[3] .. " fois"); end
	end	
	self.locationNode:SetValue(warband.loc);
	self.localisationPOINode:SetValue(warband.closedPOI);
	self.localisationPOINode:SetVisible(warband.closedPOI~=nil and warband.closedPOI~="TBD");
	-- if(warband.spawnShared~=nil and warband.spawnShared~="TBD") then
		-- self.spawnsharedNode:SetValue(warband.spawnShared);
		-- self.spawnsharedNode:SetVisible(true);	
	-- else
		-- self.spawnsharedNode:SetVisible(false);	
	-- end
	self.spawnsharedNode:SetValue(warband.spawnShared);
	
	self.infoNode:SetPrintable(warband.poi==nil and warband.multipoi==nil);
	self.statNode:SetPrintable(warband.poi==nil and warband.multipoi==nil);
	
	self.wb = warband;
end

function WarbandPane:UpdateRewardLabel(cmp, position, warband)  
	if(table.getn(warband.rewards)>=position) then
		cmp:SetVisible(true);
		if(type(warband.rewards[position][1].picture)=='string') then
			cmp:SetBackground("WalmPlugins/WarbandsSlayer/resources/"..warband.rewards[position][1].picture);
		else
			cmp:SetBackground(warband.rewards[position][1].picture);
		end
		if(cmp.tooltip ~= nil) then
			cmp.tooltip:Free();
			cmp.tooltip = nil;
		end
		if(warband.rewards[position][1].CreateTooltip ~= nil) then
			cmp.tooltip = warband.rewards[position][1].CreateTooltip(cmp, warband.rewards[position][2], warband.rewards[position][3]);
		end
		if(warband.rewards[position][1].showQuantity == true) then
			cmp.counter:SetText(warband.rewards[position][2]);
		else
			cmp.counter:SetText("");
		end
	else
		cmp:SetBackground(nil);
		cmp:SetVisible(false);
	end
end