WarbandsNode = class( Turbine.UI.TreeNode );

function WarbandsNode:Constructor(wb, region)
	self.warband = wb;
	self.region = region;
	
	Turbine.UI.TreeNode.Constructor( self );    	
	self:SetSize( 312, 35 );
	self:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	
	self.labelLevel = Turbine.UI.Label();
	self.labelLevel:SetParent( self );
	self.labelLevel:SetSize( 27, 16 );
	self.labelLevel:SetPosition( 40, 4 );
	self.labelLevel:SetZOrder(100);
	self.labelLevel:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 );	
	self.labelLevel:SetTextAlignment( Turbine.UI.ContentAlignment.TopLeft );
	self.labelLevel:SetMouseVisible( false );
	self.labelLevel:SetText(value);

	self.labelValue = Turbine.UI.Label();
	self.labelValue:SetParent( self );
	self.labelValue:SetSize( 240, 26 );
	self.labelValue:SetPosition( 71, 4 );
	self.labelValue:SetZOrder(100);
	self.labelValue:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 );	
	self.labelValue:SetTextAlignment( Turbine.UI.ContentAlignment.TopLeft );
	self.labelValue:SetMouseVisible( false );
	self.labelValue:SetText(value);

	self.iconQuest = Turbine.UI.Control();
	self.iconQuest:SetParent( self );
	self.iconQuest:SetSize( 22, 23 );
	self.iconQuest:SetPosition( self:GetWidth()-30, 6 );
	self.iconQuest:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.iconQuest:SetMouseVisible( false );
	self.difficultyIcone = Turbine.UI.Control();
	self.difficultyIcone:SetParent( self );
	self.difficultyIcone:SetSize( 11, 12 );
	self.difficultyIcone:SetPosition( 42, 22 );
	self.difficultyIcone:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.difficultyIcone:SetMouseVisible( false );	

	self.hightlight_middle = Turbine.UI.Label();
	self.hightlight_middle:SetParent( self );
	self.hightlight_middle:SetSize( self:GetWidth()-16, self:GetHeight() );
	self.hightlight_middle:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.hightlight_middle:SetPosition( 8, 0 );
	self.hightlight_middle:SetBackground( "WalmPlugins/WarbandsSlayer/resources/TdGCartouche/hightlight_middle.tga" );
	self.hightlight_middle:SetMouseVisible( false );
	self.hightlight_middle:SetVisible( false );
	self.hightlight_left = Turbine.UI.Label();
	self.hightlight_left:SetParent( self );
	self.hightlight_left:SetSize( 8, 36 );
	self.hightlight_left:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.hightlight_left:SetPosition( 0, 0 );
	self.hightlight_left:SetBackground( "WalmPlugins/WarbandsSlayer/resources/TdGCartouche/hightlight_left.tga" );
	self.hightlight_left:SetMouseVisible( false );	
	self.hightlight_left:SetVisible( false );	
	self.hightlight_right = Turbine.UI.Label();
	self.hightlight_right:SetParent( self );
	self.hightlight_right:SetSize( 8, 36 );
	self.hightlight_right:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.hightlight_right:SetPosition( self:GetWidth()-8, 0 );
	self.hightlight_right:SetBackground( "WalmPlugins/WarbandsSlayer/resources/TdGCartouche/hightlight_right.tga" );
	self.hightlight_right:SetMouseVisible( false );	
	self.hightlight_right:SetVisible( false );	

	self.SelectedChanged = function (o, e)
		self.hightlight_middle:SetVisible(self:IsSelected());
		self.hightlight_left:SetVisible(self:IsSelected());
		self.hightlight_right:SetVisible(self:IsSelected());
	end

	self.cooldown = false;	
	self.lastKillDate = nil;
	self:UpdateWBNodeStatus(self.warband.id, nil, true);	
	
	self:CreateIconeLabel();	
end

function WarbandsNode:CreateIconeLabel()	
	if(self.warband~=nil) then
		self.difficultyIcone:SetBackground("WalmPlugins/WarbandsSlayer/resources/difficulty/"..self.warband.size.."_mini.tga");
		local playerlvl = Turbine.Gameplay.LocalPlayer.GetInstance().GetLevel();
		local diff = self.warband.level - playerlvl;
		if(diff>=1 and diff<=-1) then
			self:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/white.tga");
		elseif(diff==-2 or diff==-3) then
			self:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/blue.tga");
			self.labelLevel:SetForeColor( Turbine.UI.Color(45/255, 80/255, 130/255) );
			self.labelValue:SetForeColor( Turbine.UI.Color(45/255, 80/255, 130/255) );
		elseif(diff==-4 or diff==-5) then
			self:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/cyan.tga");
			self.labelLevel:SetForeColor( Turbine.UI.Color(0, 1, 1) );
			self.labelValue:SetForeColor( Turbine.UI.Color(0, 1, 1) );
		elseif(diff<=-6 and diff>=-8) then 
			self:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/green.tga");
			self.labelLevel:SetForeColor( Turbine.UI.Color(0, 1, 0) );
			self.labelValue:SetForeColor( Turbine.UI.Color(0, 1, 0) );
		elseif(diff<-8) then
			self:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/grey.tga");
			self.labelLevel:SetForeColor( Turbine.UI.Color(0.5, 0.5, 0.5) );
			self.labelValue:SetForeColor( Turbine.UI.Color(0.5, 0.5, 0.5) );
		elseif(diff==2 or diff==3) then
			self:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/yellow.tga");
			self.labelLevel:SetForeColor( Turbine.UI.Color(1, 1, 0) );
			self.labelValue:SetForeColor( Turbine.UI.Color(1, 1, 0) );
		elseif(diff==4 or diff==5) then
			self:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/orange.tga");
			self.labelLevel:SetForeColor( Turbine.UI.Color(1, 0.5, 0) );
			self.labelValue:SetForeColor( Turbine.UI.Color(1, 0.5, 0) );
		elseif(diff==6 or diff==7) then 
			self:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/red.tga");
			self.labelLevel:SetForeColor( Turbine.UI.Color(1, 0, 0) );
			self.labelValue:SetForeColor( Turbine.UI.Color(1, 0, 0) );
		elseif(diff>7) then 
			self:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/purple.tga");	
			self.labelLevel:SetForeColor( Turbine.UI.Color(150/255, 0, 0.5) );
			self.labelValue:SetForeColor( Turbine.UI.Color(150/255, 0, 0.5) );
		else
			self:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/white.tga");
		end
		self.labelLevel:SetText("["..self.warband.level.."]");
		self.labelValue:SetText(self.warband.name);
		-- self.labelLevel:SetPosition(42, 4);
		-- self.labelLevel:SetSize(300, 16);		
	end
end

function WarbandsNode:UpdateWBNodeStatus(wbid, warbandLastKillDate, cdUp, alwaysOn)
	if(self.warband.id == wbid) then
		if(warbandLastKillDate~=nil and self.warband.repeatable==false and alwaysOn==nil) then
			self.iconQuest:SetBackground( "WalmPlugins/WarbandsSlayer/resources/green_check.tga" );
		elseif(alwaysOn~=nil and alwaysOn==true) then
			self.iconQuest:SetBackground( "WalmPlugins/WarbandsSlayer/resources/green_check.tga" );
		elseif((alwaysOn==nil or alwaysOn==false) and not cdUp ) then			
			self.iconQuest:SetBackground( "WalmPlugins/WarbandsSlayer/resources/hourglass2.tga" );
		else
			self.iconQuest:SetBackground( nil );	
		end
		self.cooldown = cdUp;	
		self.lastKillDate = warbandLastKillDate;
	end
end

function WarbandsNode:AppliFilters(filters)
	local shouldshow = 1;
	if(self.warband~= nil and filters~=nil) then		
		if(filters.show1 and self.warband.size==1) then
			shouldshow = 0;
		elseif(filters.show3 and self.warband.size==3) then
			shouldshow = 0;
		elseif(filters.show6 and self.warband.size==6) then
			shouldshow = 0;
		elseif(filters.show12 and self.warband.size==12) then
			shouldshow = 0;
		elseif(not filters.todo and ((self.warband.repeatable==nil or self.warband.repeatable==true) and self.cooldown)) then
			shouldshow = 0;
		elseif(not filters.todo and self.lastKillDate==nil and self.warband.repeatable==false) then
			shouldshow = 0;			
		elseif(not filters.done and (not self.cooldown or (self.lastKillDate~=nil and self.warband.repeatable==false))) then
			shouldshow = 0;
		elseif(string.find(string.lower(self.warband.name), filters.search)==nil) then
			shouldshow = 0;
		elseif(not filters.unrepeat and self.warband.repeatable~=nil and self.warband.repeatable==false) then
			shouldshow = 0;
		elseif((filters.tab==nil or filters.tab==1) and not (self.warband.enemyType==nil or self.warband.enemyType==1)) then
			shouldshow = 0;
		elseif(filters.tab==2 and self.warband.enemyType~=2) then
			shouldshow = 0;
		elseif(filters.tab==3 and self.warband.poi==nil and self.warband.multipoi==nil) then
			shouldshow = 0;				
		end
		
		if(filters.targetEriador==false and self.region==1)then
			shouldshow = 0;
		elseif(filters.targetRhovanion==false and self.region==2)then
			shouldshow = 0;
		elseif(filters.targetGondor==false and self.region==3)then
			shouldshow = 0;
		elseif(filters.filtre_fanorien==false and self.region==4)then
			shouldshow = 0;
		end

		
		if(shouldshow==1) then
			self:SetSize(312, 35);
		else
			self:SetSize(312, 0);
		end
	end
	return shouldshow;
end

function WarbandsNode:ExpandAll()
	self:SetExpanded(true);
	for i=1, self:GetChildNodes():GetCount(), 1 do
		self:GetChildNodes():Get(i):ExpandAll();
	end
end

function WarbandsNode:CollapseAll()
	self:SetExpanded(false);
	for i=1, self:GetChildNodes():GetCount(), 1 do
		self:GetChildNodes():Get(i):CollapseAll();
	end	
end