WizzardDialog = class( Turbine.UI.Lotro.Window );

WizzardSlideLayouts = {
	SPLASH_SCREEN={ -- image 
		PictureTop = 100;
	},
	TUTO_SCREEN={
	
	};

};

Slides = {
	{
		subTitle="Mort aux Troupes de Guerre !";
		title="Warbands Slayer";
		layout=WizzardSlideLayouts.SPLASH_SCREEN;
		picturePos = {x=110, y=100};
		pictureSize = {width=283, height=169};
		picture = "WalmPlugins/WarbandsSlayer/resources/wizzard/SplashScreen.tga";
		titleTop = 40; subtitleTop = 70;
	},
	{
	
	}
}

function WizzardDialog:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );
	
	self:SetSize( 500, 350 );
	local width, height = Turbine.UI.Display.GetSize();		
	self:SetPosition( (width-self:GetWidth())/2, (height-self:GetHeight())/2 );
	self:SetVisible(false);
	
	self:SetText( "Bienvenue !" );	
	
	self.alwaysLaunchCheckBox = Turbine.UI.Lotro.CheckBox();
	self.alwaysLaunchCheckBox:SetParent( self );
	self.alwaysLaunchCheckBox:SetMultiline( false );
	self.alwaysLaunchCheckBox:SetPosition( 30, self:GetHeight()-30 );
	self.alwaysLaunchCheckBox:SetSize( 360, 20 );
	self.alwaysLaunchCheckBox:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	self.alwaysLaunchCheckBox:SetText( " Ne plus jamais lancer l'assistant" );
	self.alwaysLaunchCheckBox:SetChecked((Preferences.wizzard==nil or Preferences.wizzard==true));
	self.alwaysLaunchCheckBox:SetMouseVisible( false );	
	
	self:CreateComponents();
	self:ApplySlideLayout(Slides[1]);
	
	
	self.Closed = function(sender, args)
		self:Stop();
	end
end

function WizzardDialog:CreateComponents()
	self.nextButton = Turbine.UI.Lotro.Button();
	self.nextButton:SetParent( self );
	self.nextButton:SetPosition( self:GetWidth()-200, self:GetHeight()-50 );
	self.nextButton:SetSize( 90, 20 );
	self.nextButton:SetText( "Suivant" );
	self.nextButton:SetMouseVisible( false );	

	self.closeButton = Turbine.UI.Lotro.Button();
	self.closeButton:SetParent( self );
	self.closeButton:SetPosition( self:GetWidth()-100, self:GetHeight()-50 );
	self.closeButton:SetSize( 90, 20 );
	self.closeButton:SetText( "Fermer" );
	self.closeButton:SetMouseVisible( false );	

	self.titleLibelle = Turbine.UI.Label();
	self.titleLibelle:SetSize( self:GetWidth()-20, 16);
	self.titleLibelle:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.titleLibelle:SetParent( self );
	self.subtitleLibelle = Turbine.UI.Label();
	self.subtitleLibelle:SetSize( self:GetWidth()-20, 16);
	self.subtitleLibelle:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.subtitleLibelle:SetParent( self );
	
	self.commentLibelle = Turbine.UI.Label();
	self.commentLibelle:SetSize( self:GetWidth()-20, 50);
	self.commentLibelle:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.commentLibelle:SetParent( self );
	
	self.pictureLibelle = Turbine.UI.Label();
	self.pictureLibelle:SetParent( self );
end

function WizzardDialog:ApplySlideLayout(slide)
	if(slide==nil or slide.layout==nil) then
		self.titleLibelle:SetText("");
		self.subtitleLibelle:SetText("");
		self.commentLibelle:SetText("");
		self.pictureLibelle:SetBackground(nil);
	elseif(slide.layout==WizzardSlideLayouts.SPLASH_SCREEN) then
		self.titleLibelle:SetText(slide.title);
		self.subtitleLibelle:SetText(slide.subTitle);
		self.commentLibelle:SetText(slide.comment);
		self.pictureLibelle:SetPosition(slide.picturePos.x, slide.picturePos.y);
		self.pictureLibelle:SetSize(slide.pictureSize.width, slide.pictureSize.height);		
		self.pictureLibelle:SetBackground(slide.picture);
		self.titleLibelle:SetPosition(10, slide.titleTop);
		self.subtitleLibelle:SetPosition(10, slide.subtitleTop);
	else
		Turbine.Shell.WriteLine("Invalid Layout");
	end

end

function WizzardDialog:GetName()
	return "Warbands";
end

function WizzardDialog:IsRunning()
	return ( self ~= nil );
end

function WizzardDialog:Stop()
	self = nil;
end
